diff -r 411de35de7fc -r 78219b10be7c libinterp/corefcn/stack-frame.cc
--- a/libinterp/corefcn/stack-frame.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/corefcn/stack-frame.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -90,6 +90,8 @@
 class scope_stack_frame;
 #if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
 class bytecode_fcn_stack_frame;
+class bytecode_script_stack_frame;
+class bytecode_nested_fcn_stack_frame;
 #endif
 
 class stack_frame_walker
@@ -121,113 +123,112 @@
   virtual void
   visit_bytecode_fcn_stack_frame (bytecode_fcn_stack_frame&) = 0;
 
+  virtual void
+  visit_bytecode_script_stack_frame (bytecode_script_stack_frame&) = 0;
+
+  virtual void
+  visit_bytecode_nested_fcn_stack_frame (bytecode_nested_fcn_stack_frame&) = 0;
+
 #endif
 };
 
 #if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
 
-// bytecode_fcn_stack_frame is for the VM.
+// Base class for bytecode_fcn_stack_frame, bytecode_script_stack_frame and bytecode_nested_fcn_stack_frame
+// covering common functionality.
 //
-// The VM stack does not directly translate to the tree walker's stack,
-// so there is a translation table to make accessing the VM stack opaque
-// for non-VM use.
+// The bytecode interpreter stack does not directly translate to the tree_evaluator's stack,
+// so there is a translation table to make accessing the bytecode interpreter stack opaque
+// for non-bytecode interpreter use.
 //
 // The octave_values are not acctually stored in the bytecode_fcn_stack_frame
-// object, but on the VM stack. Extra values created by eg. 'eval ("e = 3;")'
-// are stored in this frame object though.
-class bytecode_fcn_stack_frame : public stack_frame
+// object, but on the bytecode interpreter's stack. Extra values created by eg. 'eval ("e = 3;")'
+// are stored in these frame objects though.
+
+class bytecode_frame : public stack_frame
 {
 public:
-
-  enum class bytecode_offsets
+  // Dont allow copying, moving etc
+  bytecode_frame () = delete;
+  bytecode_frame (const bytecode_frame& elt) = delete;
+  bytecode_frame& operator = (const bytecode_frame& elt) = delete;
+  bytecode_frame& operator = (bytecode_frame&& elt) = delete;
+
+  bytecode_frame (tree_evaluator& tw,
+                  std::size_t index,
+                  const std::shared_ptr<stack_frame>& parent_link,
+                  const std::shared_ptr<stack_frame>& static_link,
+                  const std::shared_ptr<stack_frame>& access_link,
+                  vm &vm, octave_user_code *fcn,
+                  int nargout, int nargin) 
+    : stack_frame (tw, index, parent_link, static_link, access_link),
+    m_unwind_data (vm.m_unwind_data), // TODO: m_unwind_data should be replaced with a bytecode pointer instead
+    m_stack_start (vm.m_sp),
+    m_fcn (fcn),
+    m_name_data (vm.m_name_data),
+    m_code (vm.m_code),
+    m_ip (0),
+    m_nargout (nargout),
+    m_nargin (nargin)
+    {}
+
+  unwind_data *m_unwind_data;
+  stack_element *m_stack_start;
+  octave_user_code *m_fcn;
+  std::string *m_name_data;
+  unsigned char *m_code;
+  int m_ip;
+  int m_nargout;
+  int m_nargin;
+
+  // Needed to see how many shared_pointers are poing to the frame object
+  std::weak_ptr<stack_frame> m_weak_ptr_to_self;
+  
+  // Number of symbols at compile time (includes VM internal symbols)
+  unsigned n_compiled_syms () const
   {
-    DATA_NLOCALS = 2,
-  };
-
-  bytecode_fcn_stack_frame () = delete;
-
-  bytecode_fcn_stack_frame (tree_evaluator& tw,
-                            octave_user_code *fcn,
-                            std::size_t index,
-                            const std::shared_ptr<stack_frame>& parent_link,
-                            const std::shared_ptr<stack_frame>& static_link,
-                            vm &vm,
-                            int nargout, int nargin)
-    : stack_frame (tw, index, parent_link, static_link,
-                   nullptr),
-      m_fcn (fcn),
-      m_unwind_data (vm.m_unwind_data),
-      m_name_data (vm.m_name_data),
-      m_stack_start (vm.m_sp),
-      m_code (vm.m_code),
-      m_size (m_unwind_data->m_ids_size),
-      // The above fields in vm change during execution so we need to store them in the frame
-      m_vm (&vm),
-      m_ip (0),
-      m_nargin (nargin),
-      m_nargout (nargout)
+    return m_unwind_data->m_ids_size;
+  }
+
+  // Number of user symbols at compile time
+  unsigned n_compiled_usr_syms () const
+  {
+    return m_unwind_data->m_n_orig_scope_size;
+  }
+
+  unsigned n_extra_size () const
+  {
+    return m_lazy_data ? m_lazy_data->m_extra_slots.size () : 0;
+  }
+
+  unsigned n_compiled_frame_depth () const
   {
-    // If the function scope has more variables now due to something adding e.g.
-    // a global too it after the compilation of the function was done we need
-    // to resize the bytecode frame size.
-    std::size_t n_syms =  fcn->scope_num_symbols ();
-
-    m_orig_size = m_unwind_data->m_n_orig_scope_size;
-
-    // If any symbols been added to the scope since the compilation we allocate room for
-    // them on the dynamic stack frame. Unless it is a script, which should put stuff in the
-    // eval frame.
-    if (n_syms > m_orig_size && !fcn->is_user_script ())
+    return m_unwind_data->m_external_frame_offset_to_internal.size ();
+  }
+
+  void vm_clear_for_cache ()
+  {
+    m_parent_link = nullptr;
+    m_static_link = nullptr;
+    m_access_link = nullptr;
+    m_dispatch_class.clear ();
+
+    dispose ();
+  }
+
+  std::shared_ptr<stack_frame> get_ith_access_link (unsigned n) const
+  {
+    std::shared_ptr<stack_frame> nxt = access_link ();
+
+    while (n--)
       {
-        int n_to_add = n_syms - m_orig_size;
-        // Make room for the extra symbols
-        internal_resize (internal_size () + n_to_add);
-
-        // We need to get the names of the extra symbols too
-        auto scope = get_scope ();
-        auto &sym_map = scope.symbols ();
-
-        for (auto &kv : sym_map)
-          {
-            symbol_record &sr = kv.second;
-            if (sr.frame_offset ())
-              continue;
-            unsigned offset = sr.data_offset ();
-            if (offset >= m_orig_size)
-              internal_set_extra_name (external_to_local_offset (offset), sr.name ());
-          }
+        if (nxt)
+          nxt = nxt->access_link ();
       }
+
+    return nxt;
   }
 
-  bytecode_fcn_stack_frame (const bytecode_fcn_stack_frame& elt)
-    : stack_frame(elt.m_evaluator, elt.m_index, elt.m_parent_link,
-                  elt.m_static_link, elt.m_access_link)
-  {
-    // A copy of a bytecode frame has no pointers to the actual VM stack or VM itself.
-    m_nargin = elt.m_nargin;
-    m_nargout = elt.m_nargout;
-    m_name_data = elt.m_name_data;
-    m_size = elt.m_size;
-    m_orig_size = elt.m_orig_size;
-    m_ip = elt.m_ip;
-    m_unwind_data = elt.m_unwind_data; // TODO: Ownership?
-    m_size = m_unwind_data->m_ids_size;
-
-    if (elt.m_lazy_data)
-      {
-        auto &lazy = lazy_data ();
-
-        lazy.m_extra_slots = elt.m_lazy_data->m_extra_slots;
-        lazy.m_extra_names = elt.m_lazy_data->m_extra_names;
-      }
-  }
-
-  bytecode_fcn_stack_frame&
-  operator = (const bytecode_fcn_stack_frame& elt) = delete;
-
-  bytecode_fcn_stack_frame&
-  operator = (bytecode_fcn_stack_frame&& elt) = delete;
-
   // vm_clear_for_cache () and the dtor need to mirror eachother
   // so they both call dispose()
   void dispose ()
@@ -237,7 +238,7 @@
         if (m_lazy_data->m_stack_cpy)
           {
             // Note: int nargout at offset 0
-            for (unsigned i = 1; i < m_size; i++)
+            for (unsigned i = 1; i < n_compiled_syms (); i++)
               m_lazy_data->m_stack_cpy[i].ov.~octave_value ();
             delete [] m_lazy_data->m_stack_cpy;
           }
@@ -247,94 +248,6 @@
       }
   }
 
-  ~bytecode_fcn_stack_frame ()
-  {
-    // vm_clear_for_cache () need to mirror the dtor
-    dispose ();
-  }
-
-
-  void local_to_external_offset (size_t local_offset, size_t &external_offset_out, size_t &frame_offset_out) const
-  {
-    for (size_t frame_offset = 0; frame_offset < m_unwind_data->m_external_frame_offset_to_internal.size (); frame_offset++)
-      {
-        for (auto it : m_unwind_data->m_external_frame_offset_to_internal[frame_offset])
-          {
-            size_t local_tmp = it.second;
-            if (local_tmp != local_offset)
-              continue;
-
-            external_offset_out = it.first;
-            frame_offset_out = frame_offset;
-
-            return;
-          }
-      }
-
-    if (local_offset < m_size)
-      error ("VM internal error: Invalid internal offset. Smaller than original size and not in table");
-
-    external_offset_out = local_offset - m_size + m_orig_size;
-    frame_offset_out = 0;
-  }
-
-  std::size_t external_to_local_offset (std::size_t external_offset, std::size_t frame_offset = 0) const
-  {
-    auto it = m_unwind_data->m_external_frame_offset_to_internal.at (frame_offset).find (external_offset);
-    if (it == m_unwind_data->m_external_frame_offset_to_internal[frame_offset].end ())
-    {
-      CHECK_PANIC (frame_offset == 0);
-
-      if (external_offset < m_orig_size)
-        error ("VM internal error: Invalid external offset. Smaller than original size and not in table");
-      // The offsets that are not in the original translation table are in the extra slots added dynamically
-      return m_size + (external_offset - m_orig_size);
-    }
-
-    return it->second;
-  }
-
-  // Returns true if the symbol with the external offset and frame offset is stored in this frame.
-  // Note that this does not imply that frame offset is zero, if the return value is true.
-  bool maybe_external_to_local_offset (std::size_t external_offset, std::size_t frame_offset,
-                                       std::size_t &internal_offset_out, bool &allready_added_out) const
-  {
-    allready_added_out = false;
-
-    if (frame_offset >= m_unwind_data->m_external_frame_offset_to_internal.size ())
-      return false;
-
-    auto it = m_unwind_data->m_external_frame_offset_to_internal.at (frame_offset).find (external_offset);
-    bool found = it != m_unwind_data->m_external_frame_offset_to_internal[frame_offset].end ();
-
-    if (frame_offset == 0 && !found)
-      {
-        if (external_offset < m_orig_size)
-          error ("VM internal error: Invalid external offset. Smaller than original size and not in table");
-        // The offsets that are not in the original translation table are in the extra slots added dynamically
-        internal_offset_out = m_size + (external_offset - m_orig_size);
-        allready_added_out = internal_offset_out < internal_size ();
-        return true;
-      }
-    else if (!found)
-      return false;
-
-    internal_offset_out = it->second;
-    allready_added_out = true;
-
-    return true;
-  }
-
-  void vm_clear_for_cache ()
-  {
-    m_parent_link = nullptr;
-    m_static_link = nullptr;
-    m_access_link = nullptr;
-    m_dispatch_class.clear ();
-
-    dispose ();
-  }
-
   // Since a reference to the stackframe can be saved somewhere
   // we need to check at stack unwind in the VM if that is the case
   // and save the variables on the VM stack in this frame object so
@@ -369,17 +282,12 @@
         m_code = nullptr;
         m_name_data = nullptr;
         m_unwind_data = nullptr;
-        m_vm = nullptr;
 
         return;
       }
 
-    // These pointers might become invalid
-    m_vm = nullptr;
-    //m_unwind_data  = nullptr;
-
     // Copy the stack to the frame
-    size_t stack_slots = m_size;
+    size_t stack_slots = n_compiled_syms ();
 
     lazy_data ();
 
@@ -387,289 +295,127 @@
 
     m_lazy_data->m_stack_cpy[0].i = m_stack_start[0].i; // Copy int nargout at offset 0
     // Copy each octave_value in slots on the stack
-    for (unsigned i = 1; i < m_size; i++)
+    for (unsigned i = 1; i < n_compiled_syms (); i++)
       new (&m_lazy_data->m_stack_cpy[i].ov) octave_value {m_stack_start[i].ov};
 
     m_stack_start = m_lazy_data->m_stack_cpy;
   }
 
-  std::size_t size () const
-  {
-    return m_orig_size +
-      (m_lazy_data ? m_lazy_data->m_extra_slots.size () : 0);
-  }
-
-  std::size_t internal_size () const
-  {
-    return m_size +
-      (m_lazy_data ? m_lazy_data->m_extra_slots.size () : 0);
-  }
-
-  void resize (std::size_t arg)
-  {
-    int diff = static_cast<int> (arg) - static_cast<int> (size ());
-
-    if (diff > 0)
-      internal_resize (internal_size () + diff);
-  }
-
-  void internal_set_extra_name (std::size_t local_offset, std::string name)
+  // To keep down the footprint of the frame some seldom used
+  // variables are lazy initialized and stored in *m_lazy_data
+  struct lazy_data_struct
   {
-    std::size_t extra_offset = local_offset - m_size;
-    std::size_t extra_size = (m_lazy_data ? m_lazy_data->m_extra_slots.size () : 0);
-
-    if (!m_lazy_data || extra_offset >= extra_size)
-      panic ("VM internal panic: Trying to set extra slot name out of range");
-
-    m_lazy_data->m_extra_names.at (extra_offset) = name;
-  }
-
-  void internal_resize (std::size_t arg)
+    octave_value m_ignored;
+    octave_value m_arg_names;
+    octave_value m_saved_warnings_states;
+
+    std::vector<octave_value> m_extra_slots;
+
+    unwind_protect *m_unwind_protect_frame = nullptr;
+    stack_element *m_stack_cpy = nullptr;
+    bool m_is_script;
+  };
+
+  lazy_data_struct & lazy_data ()
   {
-    // Not ok to resize for scripts. Extra slots should be in the eval frame.
-    CHECK_PANIC (!m_fcn->is_user_script ());
-
-    int diff = static_cast<int> (arg) - static_cast<int> (internal_size ());
-
-    if (diff > 0)
-      {
-        auto &lazy = lazy_data ();
-        lazy.m_extra_slots.resize (lazy.m_extra_slots.size () + diff);
-
-        lazy.m_extra_names.resize (lazy.m_extra_names.size () + diff);
-      }
+    if (!m_lazy_data)
+      m_lazy_data = new lazy_data_struct {};
+    return *m_lazy_data;
   }
 
+  lazy_data_struct & clazy_data () const
+  {
+    if (!m_lazy_data)
+      panic ("VM internal panic. Lazy data not set");
+    return *m_lazy_data;
+  }
+
+  lazy_data_struct *m_lazy_data = nullptr;
+
   bool slot_is_global (std::size_t local_offset) const
   {
-    if (local_offset >= m_size)
+    octave_value *pov;
+
+    if (local_offset >= n_compiled_syms ())
       {
-        if (!m_lazy_data)
-          panic ("bytecode_fcn_stack_frame::slot_is_global(%zu): Bad request", local_offset);
-
-        octave_value ov = m_lazy_data->m_extra_slots.at (local_offset - m_size);
-        if (!ov.is_ref ())
-          return false;
-        return ov.ref_rep ()->get_scope_flag () == GLOBAL;
+        CHECK_PANIC (m_lazy_data);
+        pov = &m_lazy_data->m_extra_slots.at (local_offset - n_compiled_syms ());
       }
-
-    octave_value &ov = m_stack_start [local_offset].ov;
-    if (!ov.is_ref ())
+    else
+      pov = &m_stack_start [local_offset].ov;
+    
+    if (!pov->is_ref ())
       return false;
 
-    return ov.ref_rep ()->get_scope_flag () == GLOBAL;
+    return pov->ref_rep ()->get_scope_flag () == GLOBAL;
   }
 
   bool slot_is_persistent (std::size_t local_offset) const
   {
-    if (local_offset >= m_size)
-      {
-        if (!m_lazy_data)
-          panic ("bytecode_fcn_stack_frame::slot_is_global(%zu): Bad request", local_offset);
-        octave_value ov = m_lazy_data->m_extra_slots.at (local_offset - m_size);
-        if (!ov.is_ref ())
-          return false;
-        return ov.ref_rep ()->get_scope_flag () == PERSISTENT;
-      }
-
-    octave_value &ov = m_stack_start [local_offset].ov;
-    if (!ov.is_ref ())
-      return false;
-    return ov.ref_rep ()->get_scope_flag () == PERSISTENT;
-  }
-
-  stack_frame::scope_flags get_scope_flag_internal (std::size_t external_offset, std::size_t frame_offset) const
-  {
-    std::size_t local_offset;
-    bool allready_added;
-    bool in_this_frame = maybe_external_to_local_offset (external_offset, frame_offset, local_offset, allready_added);
-
-    // Note, quirk: A variable that is not added to a nested frame is not to be reported as global
-    // eventhough it is global in the parent frame.
-    if (!in_this_frame)
-      {
-        if (!m_fcn->is_nested_function ())
-          error ("VM internal error: Invalid call to get_scope_flag_internal");
-
-        return LOCAL;
-      }
-
-    // Is the slot on the original bytecode stack frame?
-    if (local_offset < m_size)
+    octave_value *pov;
+
+    if (local_offset >= n_compiled_syms ())
       {
-        octave_value ov = m_stack_start [local_offset].ov;
-
-        if (!ov.is_ref ())
-          return LOCAL;
-        return ov.ref_rep ()->get_scope_flag ();
-      }
-
-    size_t extra_offset = local_offset - m_size;
-    if (m_lazy_data && extra_offset < m_lazy_data->m_extra_slots.size ())
-      {
-        octave_value ov = m_lazy_data->m_extra_slots.at (extra_offset);
-        if (!ov.is_ref ())
-          return LOCAL;
-        return ov.ref_rep ()->get_scope_flag ();
-      }
-
-    return LOCAL;
-  }
-
-  stack_frame::scope_flags get_scope_flag (std::size_t external_offset) const
-  {
-    return get_scope_flag_internal (external_offset, 0);
-  }
-
-  void set_scope_flag (std::size_t external_offset, scope_flags flag)
-  {
-    scope_flags current_flag = get_scope_flag (external_offset);
-
-    bool is_global = current_flag == GLOBAL;
-    bool is_pers = current_flag == PERSISTENT;
-
-    std::size_t local_offset = external_to_local_offset (external_offset);
-
-    octave_value *ov; // Pointer to the slot
-    std::string name; // Used for globals
-
-    if (local_offset >= m_size)
-      {
-        if (!m_lazy_data)
-          error ("VM internal error: Trying to set scope flag on invalid offset");
-
-        ov = &m_lazy_data->m_extra_slots.at (local_offset - m_size);
-        name = m_lazy_data->m_extra_names.at (local_offset - m_size);
+        CHECK_PANIC (m_lazy_data);
+        pov = &m_lazy_data->m_extra_slots.at (local_offset - n_compiled_syms ());
       }
     else
-      {
-        ov = &m_stack_start [local_offset].ov;
-        name = m_name_data [local_offset];
-      }
-
-    if (flag == GLOBAL)
-      {
-        if (is_global)
-          return;
-        if (is_pers)
-          error ("VM internal error: Trying to make persistent variable global");
-        if (name == "")
-          {
-            // If a non-bytecode script adds a symbol to the scope of an eval frame
-            // that is a bytecode function we don't have any name specified in the frame
-            // so we need to look for the name in the scope, since we need it to create the
-            // global ref.
-
-            CHECK_PANIC (!m_fcn->is_user_script ()); // A bytecode script should never be an eval frame
-
-            // TODO: Linear search. Might be abit wasteful.
-            auto scope = get_scope ();
-            auto sym_map = scope.symbols ();
-            for (auto kv : sym_map)
-              {
-                symbol_record sr = kv.second;
-                if (sr.frame_offset () == 0 && sr.data_offset () == external_offset)
-                  {
-                    name = kv.first;
-                  }
-              }
-
-            if (name == "")
-              error ("VM internal error: Trying to make unnamed symbol global");
-          }
-
-        if (ov->is_ref ())
-          {
-            octave_value_ref *r = ov->ref_rep ();
-            if (r->is_local_ref ())
-              r->mark_globalness_in_owning_frame (true);
-            else
-              *ov = octave_value {new octave_value_ref_global {name}};
-          }
-        else
-          *ov = octave_value {new octave_value_ref_global {name}};
-        return;
-      }
-
-    if (flag == PERSISTENT)
-      {
-        if (is_pers)
-          return;
-        if (is_global)
-          error ("VM internal error: Trying to make global variable persistent");
-
-        *ov = octave_value {new octave_value_ref_persistent {get_scope (), static_cast<int> (external_offset)}};
-
-        return;
-      }
-
-    if (flag == LOCAL)
-      {
-        if (!is_global && !is_pers)
-          return;
-
-        // Clear the global or persistent ref on the stack
-        if (is_global || is_pers)
-          {
-            // Clear the ref in its slot
-            if (ov->is_ref ())
-              {
-                octave_value_ref *r = ov->ref_rep ();
-                if (r->is_local_ref ())
-                  r->mark_globalness_in_owning_frame (false);
-                else
-                  *ov = octave_value {};
-              }
-            else
-              *ov = octave_value {};
-          }
-
-        return;
-      }
-
-    panic ("VM internal error: Strange state: %d", flag);
+      pov = &m_stack_start [local_offset].ov;
+
+    if (!pov->is_ref ())
+      return false;
+    return pov->ref_rep ()->get_scope_flag () == PERSISTENT;
+  }
+
+  // Bytecode frames have another slot numbering than the scope objects,
+  // so there are internal functions that deal in "internal offset"
+
+  std::size_t internal_size () const
+  {
+    return n_compiled_syms () + n_extra_size ();
+  }
+
+  // Overloads of functions in the parent class stack_frame
+
+  symbol_scope get_scope () const
+  {
+    return m_fcn->scope ();
   }
 
-  stack_frame::scope_flags scope_flag (const symbol_record& sym) const
+  octave_function * function () const { return m_fcn; }
+
+  std::size_t size () const
+  {
+    return n_compiled_usr_syms () + n_extra_size ();
+  }
+
+  bool is_bytecode_fcn_frame () const { return true; }
+
+  int line () const
   {
-    std::size_t external_offset = sym.data_offset ();
-    std::size_t frame_offset = sym.frame_offset ();
-
-    if (m_fcn->is_nested_function ())
-      return get_scope_flag_internal (external_offset, frame_offset);
-
-    bool is_script = m_fcn->is_user_script ();
-
-    std::size_t local_offset;
-    bool allready_added;
-    bool in_this_frame = maybe_external_to_local_offset (external_offset, frame_offset, local_offset, allready_added);
-
-    if (frame_offset == 0 && is_script && !allready_added)
-      {
-        // Try to find the symbol in the root frame instead.
-        auto sym_in_root = access_link ()->lookup_symbol (sym.name ());
-        return access_link ()->scope_flag (sym_in_root);
-      }
-    else if (frame_offset == 0 && in_this_frame)
-      return get_scope_flag_internal (external_offset, frame_offset);
-
-    // If we have a frame offset and are in a bytecode script frame
-    // we need to follow the access links until we got the correct frame
-    auto access_frame = access_link ();
-    while (--frame_offset && access_frame)
-      access_frame = access_frame->access_link ();
-
-    if (!access_frame)
-      error ("Invalid call to bytecode_fcn_stack_frame::scope_flag()");
-
-    return access_frame->get_scope_flag (external_offset);
+    loc_entry loc = vm::find_loc (m_ip, m_unwind_data->m_loc_entry); // TODO: Does not work in nested bytecode stack frames
+    return loc.m_line;
+  }
+
+  int column () const
+  {
+    loc_entry loc = vm::find_loc (m_ip, m_unwind_data->m_loc_entry);
+    return loc.m_col;
   }
 
-  virtual octave_value get_active_bytecode_call_arg_names ()
+  unwind_protect *unwind_protect_frame ()
+  {
+    if (! lazy_data ().m_unwind_protect_frame)
+      lazy_data ().m_unwind_protect_frame = new unwind_protect ();
+
+    return lazy_data ().m_unwind_protect_frame;
+  }
+
+  octave_value get_active_bytecode_call_arg_names ()
   {
 
     // Handle ARG_NAMES
-    if (!m_unwind_data || !m_vm)
+    if (!m_unwind_data)
       return Cell {};
 
     int best_match = -1;
@@ -701,11 +447,159 @@
     return c;
   }
 
-  virtual void set_active_bytecode_ip (int ip)
+  std::string sym_name_from_external_offset (std::size_t external_offset, std::size_t frame_offset = 0)
+  {
+    auto scope = get_scope ();
+
+    for (auto &kv : scope.symbols()) // TODO: Lookup on external offset?
+      {
+        auto &rec = kv.second;
+
+        if (rec.data_offset () != external_offset)
+          continue;
+        if (rec.frame_offset () != frame_offset)
+          continue;
+
+        return rec.name ();
+      }
+
+    return "";
+  }
+
+  void set_active_bytecode_ip (int ip)
   {
     m_ip = ip;
   }
 
+  std::string inputname (int n, bool ids_only) const
+  {
+    std::string name;
+
+    octave_value ov_arg_names = get_auto_fcn_var (stack_frame::ARG_NAMES);
+    Array<std::string> arg_names = ov_arg_names.cellstr_value ();
+
+    if (n >= 0 && n < arg_names.numel ())
+      {
+        name = arg_names(n);
+
+        if (ids_only && ! m_static_link->is_variable (name))
+          name = "";
+      }
+
+    return name;
+  }
+
+  void set_nargin (int nargin) { m_nargin = nargin; }
+  void set_nargout (int nargout) { m_nargout = nargout; }
+
+  void break_closure_cycles (const std::shared_ptr<stack_frame> &frame)
+  {
+    if (m_stack_start)
+      {
+        for (unsigned i = 1; i < n_compiled_syms (); i++)
+          {
+            // break_closure_cycles () is making a clone of nil values
+            // but we want nil values to have the same m_rep pointer, on the
+            // VM stack. is_nil () wont return true on a cloned nil value.
+            if (!m_stack_start[i].ov.is_nil ())
+              m_stack_start[i].ov.break_closure_cycles (frame);
+          }
+      }
+
+    if (m_lazy_data)
+      {
+        for (octave_value &ov : m_lazy_data->m_extra_slots)
+          {
+            if (!ov.is_nil ())
+              ov.break_closure_cycles (frame);
+          }
+      }
+
+    if (m_access_link)
+      m_access_link->break_closure_cycles (frame);
+  }
+
+  // Convert external offset to internal slot offset.
+  std::size_t external_to_local_offset (std::size_t external_offset, std::size_t frame_offset = 0) const
+  {
+    auto it = m_unwind_data->m_external_frame_offset_to_internal.at (frame_offset).find (external_offset);
+    if (it == m_unwind_data->m_external_frame_offset_to_internal[frame_offset].end ())
+    {
+      CHECK_PANIC (frame_offset == 0);
+      // If the offset is smaller then the amount of user symbols, it should have been in the table
+      CHECK_PANIC (external_offset >= n_compiled_usr_syms ());
+
+      // The offsets that are not in the original translation table are in the extra slots added dynamically
+      return n_compiled_syms () + (external_offset - n_compiled_usr_syms ());
+    }
+
+    return it->second;
+  }
+
+  octave_value varval_internal (std::size_t internal_offset) const
+  {
+    octave_value *pov;
+
+    if (internal_offset < n_compiled_syms ())
+      {
+        // The symbol is on the VM stack
+        pov = &m_stack_start[internal_offset].ov;
+      }
+    else
+      {
+        // The symbol is in the extra slots in this frame object
+        pov = &clazy_data ().m_extra_slots.at (internal_offset - n_compiled_syms ());
+      }
+
+    // globals, persistent are stored as 'octave_value_ref' objects. We need to dereference those.
+    if (pov->is_ref ())
+      return pov->ref_rep ()->deref ();
+    return *pov;
+  }
+
+  // The using declaration will avoid warnings about partially-overloaded
+  // virtual functions.
+  using stack_frame::varval;
+  using stack_frame::varref;
+
+  octave_value varval (std::size_t external_offset) const
+  {
+    std::size_t local_offset = external_to_local_offset (external_offset);
+    return varval_internal (local_offset);
+  }
+
+  octave_value& varref_internal (std::size_t local_offset, bool deref_refs)
+  {
+    std::size_t extra_size = n_extra_size ();
+    std::size_t n_stack_slots = n_compiled_syms ();
+
+    octave_value *pov;
+
+    if (local_offset < n_stack_slots)
+      {
+        pov = &m_stack_start [local_offset].ov;
+      }
+    else
+      {
+        std::size_t extra_offset = local_offset - n_stack_slots;
+
+        CHECK_PANIC (m_lazy_data);
+        CHECK_PANIC (extra_offset < extra_size);
+
+        pov = &m_lazy_data->m_extra_slots.at (extra_offset);
+      }
+
+    if (deref_refs && pov->is_ref ())
+      return pov->ref_rep ()->ref ();
+    return *pov;
+  }
+
+  octave_value& varref (std::size_t external_offset, bool deref_refs)
+  {
+    std::size_t local_offset = external_to_local_offset (external_offset);
+    return varref_internal (local_offset, deref_refs);
+  }
+
   octave_value get_auto_fcn_var (auto_var_type avt) const
   {
     switch (avt)
@@ -738,13 +632,10 @@
           return m_parent_link->get_active_bytecode_call_arg_names ();
         }
         default:
-          panic ("bytecode_fcn_stack_frame::get_auto_fcn_var() : Invalid call idx=%d", static_cast<int> (avt));
+          panic ("bytecode_frame::get_auto_fcn_var() : Invalid call idx=%d", static_cast<int> (avt));
       }
   }
 
-  void set_nargin (int nargin) { m_nargin = nargin; }
-  void set_nargout (int nargout) { m_nargout = nargout; }
-
   void set_auto_fcn_var (auto_var_type avt, const octave_value& val)
   {
     switch (avt)
